
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include <unistd.h>

#define YesWindows 0


#if YesWindows 
 #include <windows.h>
#else
 #include <sys/types.h>
 #include <sys/stat.h>
 #include <fcntl.h>
 #include <termios.h>
 #include <stdio.h>
 #define BAUDRATE B9600
#endif

#define DEBUG 0

	const int SCREEN_WIDTH = 640; 
	const int SCREEN_HEIGHT = 480; 
	const int SCREEN_BPP = 32;

	//The surfaces that will be used 
	SDL_Surface *message = NULL; 
	SDL_Surface *background = NULL; 
	SDL_Surface *screen = NULL;
	SDL_Surface *dots = NULL;

	SDL_Event event;

	TTF_Font *font = NULL;

	SDL_Color textColor = { 25, 25, 25 };


	char VARI[100];
	struct BUTTON {
		int numero;		//1-boton 2-luz
		char *nombre;
		unsigned char estado;
		int x;
		int y;
		int w;
		int h;
	};

#define MAXBOTONES 20
#define MAXLUCES 20
	struct  BUTTON nboton[MAXBOTONES];
	struct  BUTTON nluz[MAXLUCES];

#if YesWindows 
char MODEMDEVICEdefault[]= "COM3";
#else
char MODEMDEVICEdefault[]= "/dev/ttyUSB0";
#endif
char *MODEMDEVICE;


SDL_Surface *load_image( char *filename )
{ 
	SDL_Surface *temp,*ima;

	temp  =IMG_Load(filename);
	if (temp == NULL){
		printf("Error al cargar %s\n", filename);
		exit(EXIT_FAILURE);
	}			 
		ima = SDL_DisplayFormat(temp);
		SDL_FreeSurface( temp );

        if( ima != NULL )
        {
            Uint32 colorkey = SDL_MapRGB( ima->format, 0, 0xFF, 0xFF );
            SDL_SetColorKey( ima, SDL_SRCCOLORKEY, colorkey );
			if(DEBUG)printf("ok al cargar %s\n", filename);
        }
	
	return ima; 
}



void apply_surface( int x, int y, SDL_Surface* source, SDL_Surface* destination )
	{ 
		SDL_Rect offset; 
		offset.x = x;
		offset.y = y;
		SDL_BlitSurface( source, NULL, destination, &offset );
	}
void apply_surfaceB( int x, int y, SDL_Surface* source, SDL_Surface* destination,SDL_Rect* clip )
	{ 
		SDL_Rect offset; 
		offset.x = x;
		offset.y = y;
		SDL_BlitSurface( source, clip, destination, &offset );
	}

int init()
{

    if( SDL_Init( SDL_INIT_EVERYTHING ) == -1 )  return 0;
 //   screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
    screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );

    if( screen == NULL )   return 0;
	
    if(TTF_Init()==-1) {
    	 printf("TTF_Init: %s\n", TTF_GetError());
   		 exit(0);
		}

    SDL_WM_SetCaption( "Control Salidas Arduino", NULL );

    return 1;
}

int load_files()
{
    background = load_image( "aserie2.jpg" );
    if( background == NULL )  return 0;
	dots = load_image( "aserie1.png" );
    if( dots == NULL )  return 0;

    font = TTF_OpenFont( "seta.ttf", 20 );
	if( font == NULL )
    {
		printf("Error cargando Font\n");
        return 0;
    }
  return 1;
}

void clean_up()
{
    SDL_FreeSurface( background );
	SDL_FreeSurface( dots );
    SDL_Quit();
}

void Paintbutton(int x,int y,int w,int h,char *texto,unsigned char tipo)
{
  int w1,h1;
 SDL_Rect clip[ 1 ];
 SDL_Surface *message;
	if(tipo==0)
	{
		clip[ 0 ].x = 0;
	    clip[ 0 ].y = 0;
    	clip[ 0 ].w = 89;
    	clip[ 0 ].h = 25;
	}
	else
	{
		clip[ 0 ].x = 89;
	    clip[ 0 ].y = 0;
    	clip[ 0 ].w = 89;
    	clip[ 0 ].h = 25;		
	}
 	apply_surfaceB( x, y, dots, screen, &clip[ 0 ] );
	message = TTF_RenderText_Solid( font,texto, textColor );
	if(TTF_SizeText(font,texto,&w1,&h1))
		{
			printf("Error tamaño texto");
		} 
		else
		{
			w1=w1/2;
			w1=45-w1;
			if(w1<0)w1=0;
		}	
	apply_surface( x+w1, y+2, message, screen );
}	


void PaintBoton(int numero,int modo)
{
  Paintbutton(nboton[numero].x,nboton[numero].y,nboton[numero].w,nboton[numero].h,nboton[numero].nombre,modo);	
}

void PaintBotones()
{
 int x;
	for(x=0;x<MAXBOTONES && nboton[x].numero!=-1 ;x++)PaintBoton(x,0);
}	

int DetecBotones(int x, int y)
{
int z;
	for(z=0;z<MAXBOTONES && nboton[z].numero!=-1 ;z++)
	{
		if(x>nboton[z].x && y>nboton[z].y && x<(nboton[z].x+nboton[z].w) && y<(nboton[z].y+nboton[z].h))
			return z;
	}
return -1;

}

void Inibotones()
{
	nboton[0].numero=1;
	nboton[0].nombre="An0";
	nboton[0].x=10;
	nboton[0].y=10;
	nboton[0].w=89;
	nboton[0].h=25;

	nboton[1].numero=1;
	nboton[1].nombre="An1";
	nboton[1].x=10;
	nboton[1].y=40;
	nboton[1].w=89;
	nboton[1].h=25;

	nboton[2].numero=1;
	nboton[2].nombre="An2";
	nboton[2].x=10;
	nboton[2].y=70;
	nboton[2].w=89;
	nboton[2].h=25;

	nboton[3].numero=1;
	nboton[3].nombre="An3";
	nboton[3].x=10;
	nboton[3].y=100;
	nboton[3].w=89;
	nboton[3].h=25;

	nboton[4].numero=1;
	nboton[4].nombre="An4";
	nboton[4].x=10;
	nboton[4].y=130;
	nboton[4].w=89;
	nboton[4].h=25;

	nboton[5].numero=1;
	nboton[5].nombre="An5";
	nboton[5].x=10;
	nboton[5].y=160;
	nboton[5].w=89;
	nboton[5].h=25;

	nboton[6].numero=1;
	nboton[6].nombre="Dig13";
	nboton[6].x=460;
	nboton[6].y=10;
	nboton[6].w=89;
	nboton[6].h=25;

	nboton[7].numero=1;
	nboton[7].nombre="Dig12";
	nboton[7].x=460;
	nboton[7].y=40;
	nboton[7].w=89;
	nboton[7].h=25;

	nboton[8].numero=1;
	nboton[8].nombre="Dig11";
	nboton[8].x=460;
	nboton[8].y=70;
	nboton[8].w=89;
	nboton[8].h=25;

	nboton[9].numero=1;
	nboton[9].nombre="Dig10";
	nboton[9].x=460;
	nboton[9].y=100;
	nboton[9].w=89;
	nboton[9].h=25;

	nboton[10].numero=1;
	nboton[10].nombre="Dig9";
	nboton[10].x=460;
	nboton[10].y=130;
	nboton[10].w=89;
	nboton[10].h=25;

	nboton[11].numero=1;
	nboton[11].nombre="Dig8";
	nboton[11].x=460;
	nboton[11].y=160;
	nboton[11].w=89;
	nboton[11].h=25;

	nboton[12].numero=1;
	nboton[12].nombre="Dig7";
	nboton[12].x=460;
	nboton[12].y=190;
	nboton[12].w=89;
	nboton[12].h=25;

	nboton[13].numero=1;
	nboton[13].nombre="Dig6";
	nboton[13].x=460;
	nboton[13].y=220;
	nboton[13].w=89;
	nboton[13].h=25;

	nboton[14].numero=1;
	nboton[14].nombre="Dig5";
	nboton[14].x=460;
	nboton[14].y=250;
	nboton[14].w=89;
	nboton[14].h=25;

	nboton[15].numero=1;
	nboton[15].nombre="Dig4";
	nboton[15].x=460;
	nboton[15].y=280;
	nboton[15].w=89;
	nboton[15].h=25;

	nboton[16].numero=1;
	nboton[16].nombre="Dig3";
	nboton[16].x=460;
	nboton[16].y=310;
	nboton[16].w=89;
	nboton[16].h=25;

	nboton[17].numero=1;
	nboton[17].nombre="Dig2";
	nboton[17].x=460;
	nboton[17].y=340;
	nboton[17].w=89;
	nboton[17].h=25;

	nboton[18].numero=-1;
}



void PaintLight(int x,int y,int w,int h,char *texto,unsigned char tipo)
{
 SDL_Rect clip[ 1 ];
 SDL_Surface *message;
   if(tipo==0)
	{
		clip[ 0 ].x = 0;
    	clip[ 0 ].y = 25;
    	clip[ 0 ].w = 89;
    	clip[ 0 ].h = 25;	
	}
	else
	{
		clip[ 0 ].x = 89;
    	clip[ 0 ].y = 25;
    	clip[ 0 ].w = 89;
    	clip[ 0 ].h = 25;			
	}
	apply_surfaceB( x, y, dots, screen, &clip[ 0 ] );
	message = TTF_RenderText_Solid( font,texto, textColor );
	apply_surface( x+28, y+2, message, screen );
}

void PaintLuz(int numero,int modo)
{
	PaintLight(nluz[numero].x,nluz[numero].y,nluz[numero].w,nluz[numero].h,nluz[numero].nombre,modo);
}

void PaintLuces()
{
	int x;
	for(x=0;x<MAXLUCES && nluz[x].numero!=-1 ;x++)
	{
		if(nluz[x].estado==0)
			PaintLuz(x,0);
		 else
			PaintLuz(x,1);
	}
}	

void IniLuces()
{
	nluz[0].numero=2;
	nluz[0].nombre="An0";
	nluz[0].estado=0;
	nluz[0].x=100;
	nluz[0].y=10;
	nluz[0].w=89;
	nluz[0].h=25;

	nluz[1].numero=2;
	nluz[1].nombre="An1";
	nluz[1].estado=0;
	nluz[1].x=100;
	nluz[1].y=40;
	nluz[1].w=89;
	nluz[1].h=25;

	nluz[2].numero=2;
	nluz[2].nombre="An2";
	nluz[2].estado=0;
	nluz[2].x=100;
	nluz[2].y=70;
	nluz[2].w=89;
	nluz[2].h=25;

	nluz[3].numero=2;
	nluz[3].nombre="An3";
	nluz[3].estado=0;	
	nluz[3].x=100;
	nluz[3].y=100;
	nluz[3].w=89;
	nluz[3].h=25;

	nluz[4].numero=2;
	nluz[4].nombre="An4";
	nluz[4].estado=0;	
	nluz[4].x=100;
	nluz[4].y=130;
	nluz[4].w=89;
	nluz[4].h=25;

	nluz[5].numero=2;
	nluz[5].nombre="An5";
	nluz[5].estado=0;	
	nluz[5].x=100;
	nluz[5].y=160;
	nluz[5].w=89;
	nluz[5].h=25;

	nluz[6].numero=2;
	nluz[6].nombre="Dig13";
	nluz[6].estado=0;
	nluz[6].x=550;
	nluz[6].y=10;
	nluz[6].w=89;
	nluz[6].h=25;

	nluz[7].numero=2;
	nluz[7].nombre="Dig12";
	nluz[7].estado=0;
	nluz[7].x=550;
	nluz[7].y=40;
	nluz[7].w=89;
	nluz[7].h=25;

	nluz[8].numero=2;
	nluz[8].nombre="Dig11";
	nluz[8].estado=0;
	nluz[8].x=550;
	nluz[8].y=70;
	nluz[8].w=89;
	nluz[8].h=25;

	nluz[9].numero=2;
	nluz[9].nombre="Dig10";
	nluz[9].estado=0;
	nluz[9].x=550;
	nluz[9].y=100;
	nluz[9].w=89;
	nluz[9].h=25;

	nluz[10].numero=2;
	nluz[10].nombre="Dig9";
	nluz[10].estado=0;
	nluz[10].x=550;
	nluz[10].y=130;
	nluz[10].w=89;
	nluz[10].h=25;

	nluz[11].numero=2;
	nluz[11].nombre="Dig8";
	nluz[11].estado=0;
	nluz[11].x=550;
	nluz[11].y=160;
	nluz[11].w=89;
	nluz[11].h=25;

	nluz[12].numero=2;
	nluz[12].nombre="Dig7";
	nluz[12].estado=0;
	nluz[12].x=550;
	nluz[12].y=190;
	nluz[12].w=89;
	nluz[12].h=25;

	nluz[13].numero=2;
	nluz[13].nombre="Dig6";
	nluz[13].estado=0;
	nluz[13].x=550;
	nluz[13].y=220;
	nluz[13].w=89;
	nluz[13].h=25;

	nluz[14].numero=2;
	nluz[14].nombre="Dig5";
	nluz[14].estado=0;
	nluz[14].x=550;
	nluz[14].y=250;
	nluz[14].w=89;
	nluz[14].h=25;

	nluz[15].numero=2;
	nluz[15].nombre="Dig4";
	nluz[15].estado=0;
	nluz[15].x=550;
	nluz[15].y=280;
	nluz[15].w=89;
	nluz[15].h=25;

	nluz[16].numero=2;
	nluz[16].nombre="Dig3";
	nluz[16].estado=0;
	nluz[16].x=550;
	nluz[16].y=310;
	nluz[16].w=89;
	nluz[16].h=25;

	nluz[17].numero=2;
	nluz[17].nombre="Dig2";
	nluz[17].estado=0;
	nluz[17].x=550;
	nluz[17].y=340;
	nluz[17].w=89;
	nluz[17].h=25;

	nluz[18].numero=-1;
}	

#if YesWindows  
int WriteSerie(HANDLE hSerial,char *c,int tamano)
{
 int bRes;
 DWORD dwError, dwNumBytesWritten=0;
              bRes=WriteFile(hSerial,c,tamano,&dwNumBytesWritten,NULL );
              if (!bRes) printf("Error mandado Bytes %u   \n",dwNumBytesWritten);	    
}
#endif





int main(int argc, char *argv[])
{
  
 	int mouse_x,mouse_y;
	int zboton=0;	
    int quit = 0;
    Uint8 *teclas; 
    
#if YesWindows 
	freopen("CON", "w", stdout); // redirects stdout
	freopen("CON", "w", stderr); // redirects stderr
#endif

    printf("%s\n",argv[0]);
	if(argc==2)
		{
		 printf("%s\n",argv[1]);
 	 	 MODEMDEVICE=argv[1];
		}
	 else
		{
		 MODEMDEVICE=MODEMDEVICEdefault;
		}
	printf("Controlador Arduino mediante interfaz ");

	printf(MODEMDEVICE);
	printf("\n");

#if YesWindows  	
 //____________Programacion serie Windows__________________________
 HANDLE hSerial;
// DCB dcbSerial;
 DCB dcbSerialParams;
 
         hSerial = CreateFile(MODEMDEVICE,GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING,0, NULL);

         if(hSerial==INVALID_HANDLE_VALUE)
           {
             if(GetLastError()==ERROR_FILE_NOT_FOUND)
              {
               printf("PUERTO NO EXISTE !! \n"); 
               return 0;
              }
           }
           else
           {
//            dcbSerial.DCBlength=sizeof(dcbSerialParams);
            if (!GetCommState(hSerial, &dcbSerialParams))
               {
                printf("Error get Status!!\n");
                return 0;
               }                           
            dcbSerialParams.BaudRate=CBR_9600;
            dcbSerialParams.ByteSize=8;
            dcbSerialParams.StopBits=ONESTOPBIT;
            dcbSerialParams.Parity=NOPARITY;

            if (!SetCommState (hSerial, &dcbSerialParams))
              {
               CloseHandle(hSerial);
               printf("Error get Status2!!\n");
               return 0;
              }           
           }
           WriteSerie(hSerial,"SETA43\n",1);
#else
//_________Programacion Linux________________________
struct termios newtermios;
int fd;


	fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY );
   	if (fd <0) 
		{
		 printf("Error puerto de comunicaciones\n");
		 exit(-1);  
		}	
  newtermios.c_cflag= BAUDRATE | CS8 | CLOCAL | CREAD;
  newtermios.c_iflag=IGNPAR;
  newtermios.c_oflag=0;
  newtermios.c_lflag=0;
  newtermios.c_cc[VMIN]=1;
  newtermios.c_cc[VTIME]=0;

  cfsetospeed(&newtermios,BAUDRATE);
  cfsetispeed(&newtermios,BAUDRATE);
 
  if (tcflush(fd,TCIFLUSH)==-1) return -1;
  if (tcflush(fd,TCOFLUSH)==-1) return -1;
  if (tcsetattr(fd,TCSANOW,&newtermios)==-1) return -1;  
	
#endif



	Inibotones();
	IniLuces ();

    if( init() == 0 ) return 1;
    if( load_files() == 0 ) return 2;

	apply_surface( 0, 0, background, screen );
    message = TTF_RenderText_Solid( font, "ARDUINO", textColor );
	apply_surface( 270, 1, message, screen );

	PaintBotones();
	PaintLuces();
    if( SDL_Flip( screen ) == -1 ) return 3;
	

    while( quit == 0 )
    {
		SDL_Delay(100);
        while( SDL_PollEvent( &event ) )
        {
			teclas = SDL_GetKeyState(NULL);
			if(teclas[SDLK_ESCAPE] ) quit = 1;
            if( event.type == SDL_QUIT )   quit = 1;
            if( event.type == SDL_KEYDOWN ) 
			{
				if(DEBUG)printf("Evento Tecla\n");				
			}
			if( event.type == SDL_MOUSEBUTTONDOWN ) {
				mouse_x=event.button.x;
				mouse_y=event.button.y;
				zboton=DetecBotones(mouse_x,mouse_y);
				if(zboton!=-1)
					{
					 if(nluz[zboton].estado==0)
						{
							nluz[zboton].estado=1;
							sprintf(VARI,"1%s",nluz[zboton].nombre);
						}
		 				else
						{
							nluz[zboton].estado=0;
							sprintf(VARI,"0%s",nluz[zboton].nombre);
						}
                     printf("%s\n",VARI);
#if YesWindows                     
                     WriteSerie(hSerial,VARI,7);
                     WriteSerie(hSerial,"\n",1);
#else
                     write(fd,VARI,7);
                     write(fd,"\n",1);             							
#endif                     
					 PaintBoton(zboton,1);
					}

					if(DEBUG)printf("Evento Raton X=%d Y=%d Boton=%d\n",mouse_x,mouse_y,zboton);					
					if( SDL_Flip( screen ) == -1 ) return 3;
			}
			if( event.type == SDL_MOUSEBUTTONUP ) {
				if(zboton!=-1){
					PaintBotones();
					PaintLuces();
					if(DEBUG)printf("RepintarBoton %d\n",zboton);
					zboton=-1;					
				}
					
				if( SDL_Flip( screen ) == -1 ) return 3;
			}
	
        }
    }
 
 
     //Free the surface and quit SDL
    clean_up();
#if YesWindows    
    CloseHandle(hSerial);
#else    
	close(fd);
#endif

    return 0;
   
}
 
